package org.simantics.scl.compiler.constants.singletons;

import org.simantics.scl.compiler.constants.FunctionValue;
import org.simantics.scl.compiler.internal.codegen.references.Val;
import org.simantics.scl.compiler.internal.codegen.utils.MethodBuilder;
import org.simantics.scl.compiler.types.TVar;
import org.simantics.scl.compiler.types.Type;
import org.simantics.scl.compiler.types.Types;
import org.simantics.scl.compiler.types.kinds.Kinds;

public class ClassConstant extends FunctionValue {
    
    private static final TVar A = Types.var(Kinds.STAR);
    public static final ClassConstant INSTANCE = new ClassConstant();
    
    private ClassConstant() {
        super(new TVar[] {A}, Types.NO_EFFECTS, Types.apply(Types.CLASS, A), 
                Types.pred(Types.VEC_COMP, A));
    }
    
    @Override
    public Type applyExact(MethodBuilder mb, Val[] parameters) {
        mb.push(parameters[0], Types.CLASS);
        return getReturnType();
    }
}