package org.simantics.scl.compiler.elaboration.expressions.records;

import org.simantics.scl.compiler.elaboration.contexts.ReplaceContext;
import org.simantics.scl.compiler.elaboration.expressions.Expression;
import org.simantics.scl.compiler.internal.parsing.Symbol;

public class FieldAssignment extends Symbol {
    public static final String WILDCARD = "..";
    
    public String name;
    public Expression value; // null if shorthand
    
    public FieldAssignment(String name, Expression value) {
        this.name = name;
        this.value = value;
    }

    public FieldAssignment replace(ReplaceContext context) {
        return new FieldAssignment(name, value == null ? null : value.replace(context));
    }
}
