package org.simantics.scl.compiler.elaboration.modules;

import org.simantics.scl.compiler.common.exceptions.InternalCompilerError;
import org.simantics.scl.compiler.types.TCon;
import org.simantics.scl.compiler.types.TVar;
import org.simantics.scl.compiler.types.Type;
import org.simantics.scl.compiler.types.kinds.Kind;

public class TypeAlias extends TypeDescriptor {   
    public TVar[] parameters;
    public Type body;
    public String documentation;
    
    public TypeAlias(TCon name, int arity) {
        super(name);
        this.parameters = new TVar[arity];
    }
    
    public TypeAlias(TCon name, TVar[] parameters, Type body) {
        super(name);
        this.parameters = parameters;
        this.body = body;
    }
    
    public int getArity() {
        return parameters.length;
    }

    @Override
    public Kind getKind() {
        throw new InternalCompilerError("Unsupported method TypeAlias.getKind invoked.");
    }
    
    @Override
    public void setDocumentation(String documentation) {
        this.documentation = documentation;
    }
    
    @Override
    public String getDocumentation() {
        return documentation;
    }
}
