package org.simantics.scl.compiler.module.repository;

import java.util.Collection;

public class ImportFailureException extends Exception {

    private static final long serialVersionUID = -5354423459876460101L;

    public final Collection<ImportFailure> failures;

    public ImportFailureException(Collection<ImportFailure> failures) {
        super(messageFromFailures(failures));
        this.failures = failures;
    }

    private static String messageFromFailures(
            Collection<ImportFailure> failures) {
        StringBuilder b = new StringBuilder();
        for(ImportFailure failure : failures)
            b.append(failure.toString()).append('\n');
        return b.toString();
    }
}
